import React, { Ref, ForwardedRef } from 'react';
import { CosmographTimeline as _CosmographTimeline, CosmographTimelineInputConfig } from '@cosmograph/cosmograph';
export type CosmographTimelineProps<Datum> = {
    style?: object;
    className?: string;
} & CosmographTimelineInputConfig<Datum>;
export type CosmographTimelineRef<Datum> = _CosmographTimeline<Datum> | undefined;
export declare function CosmographTimelineFC<Datum>({ style, className, ...config }: CosmographTimelineProps<Datum>, ref: ForwardedRef<CosmographTimelineRef<Datum>>): React.ReactElement;
export declare const CosmographTimeline: <Datum>(props: {
    style?: object | undefined;
    className?: string | undefined;
} & {
    accessor?: ((d: Datum) => number | Date) | undefined;
    filterType?: string | undefined;
    onSelection?: ((selection: [Date, Date] | [number, number] | undefined, isManuallySelected?: boolean | undefined) => void) | undefined;
} & Omit<import("@cosmograph/ui").TimelineEvents, "onBrush"> & Omit<import("@cosmograph/ui").TimelineConfigInterface, "events"> & {
    ref?: React.Ref<CosmographTimelineRef<Datum>> | undefined;
}) => React.ReactElement;
export type { CosmographTimelineInputConfig };
